<template>
  <div class="box-graphics">
    <div class="d-flex justify-end">
      <configuration
        class=""
        @reloadPlanificationCharts="reloadCharts"
      ></configuration>
      <seguimiento class="ml-5"></seguimiento>
    </div>
    <h3 class="text-center">Net Promotor Score</h3>

    <div class="resumen">
      <div class="resumen-detail">
        <div
          class="resumen-detail-item"
          v-for="(itemResumen, i) in summaryKPINegocio.resumen"
          :key="i"
        >
          <div>{{ itemResumen.description }}</div>
          <div>{{ itemResumen.value }}</div>
          <div>
            <span v-if="itemResumen.signo === '+'" class="material-icons">
              <v-img
                width="25"
                :src="require('@/assets/img/pmo/up-arrow-green.svg')"
              />
            </span>
            <span v-else>
              <v-img
                width="25"
                :src="require('@/assets/img/pmo/down-arrow-red.svg')"
            /></span>
          </div>
        </div>
      </div>
      <div class="resumen-bar">
        <StackedBars100
          :series="summaryKPINegocio.series"
          :options="summaryKPINegocio.options"
          height="150"
          title="Resumen"
        />
      </div>
    </div>
    <div class="list-top-10">
      <SimpleLine
        :series="historyKPINegocio.series"
        :options="historyKPINegocio.options"
        title="NPS Historico"
      />
    </div>
    <div class="seguimiento">
      <div class="seguimiento-periodo">
        <StackedColumns100
          v-if="ratioHistoryKPINegocio.series.length > 0"
          title="Ratio Histórico"
          :series="ratioHistoryKPINegocio.series"
          :options="ratioHistoryKPINegocio.options"
        />
      </div>
      <div class="seguimiento-costo">
        <StackedBars
          v-if="compositionKPINegocio.series.length > 0"
          title="Composición Histórica"
          :series="compositionKPINegocio.series"
          :options="compositionKPINegocio.options"
        />
      </div>
    </div>
  </div>
</template>

<script>
import Configuration from "../../components/pmo/planification/configuration.vue";
import Seguimiento from "../../components/pmo/planification/seguimiento.vue";
import KpiBusinessService from "@/services/pmo/kpi/kpiBusinessService";
//import SimpleBubbleChart from "../../components/charts/pmo/apex/bubble/SimpleBubbleChart";
//import PolarArea from "../../components/charts/pmo/apex/polar-area/PolarArea";
// getSummaryKPINegocio
// getHistoryKPINegocio
// getRatioHistoryKPINegocio
// getCompositionKPINegocio
import StackedBars100 from "../../components/charts/pmo/apex/bar/StackedBars100";
import SimpleLine from "../../components/charts/pmo/apex/line/SimpleLine";
import StackedColumns100 from "../../components/charts/pmo/apex/column/StackedColumns100";
import StackedBars from "../../components/charts/pmo/apex/bar/StackedBars";

export default {
  name: "KPIBusiness",
  components: {
    Configuration,
    Seguimiento,
    //SimpleBubbleChart,
    //PolarArea,
    StackedBars100,
    SimpleLine,
    StackedColumns100,
    StackedBars,
  },
  data() {
    return {
      charts: {
        timeLine: {
          serie: null,
        },
        stacked: {
          serie: [],
        },
      },
      summaryKPINegocio: {
        resumen: [],
        series: [],
        options: {
          chart: {
            type: "bar",
            height: 150,
            stacked: true,
            //stackType: '100%'
          },
          plotOptions: {
            bar: {
              horizontal: true,
            },
          },
          stroke: {
            width: 1,
            colors: ["#fff"],
          },
          title: {
            text: "",
          },
          xaxis: {
            categories: ["Agosto"],
          },
          tooltip: {
            y: {
              formatter: function (val) {
                return val;
              },
            },
          },
          fill: {
            opacity: 1,
          },
          legend: {
            position: "top",
            horizontalAlign: "left",
            offsetX: 40,
          },
          colors: ["#008F39", "#E5Be01", "#D7263D"],
        },
      },
      historyKPINegocio: {
        series: [],
        options: {
          chart: {
            height: 350,
            width: 800,
            type: "line",
            zoom: {
              enabled: false,
            },
          },
          colors: ["#7319D5"],
          dataLabels: {
            enabled: false,
          },
          stroke: {
            curve: "straight",
          },
          title: {
            text: "",
            align: "left",
          },
          grid: {
            row: {
              colors: ["#f3f3f3", "transparent"], // takes an array which will be repeated on columns
              opacity: 0.5,
            },
          },
          xaxis: {
            categories: [
              "Enero",
              "Febrero",
              "Marzo",
              "Abril",
              "Mayo",
              "Junio",
              "Julio",
              "Agosto",
            ],
          },
        },
      },
      ratioHistoryKPINegocio: {
        series: [],
        options: {
          chart: {
            type: "bar",
            height: 350,
            stacked: true,
            stackType: "100%",
          },
          responsive: [
            {
              breakpoint: 680,
              options: {
                legend: {
                  position: "bottom",
                  offsetX: -10,
                  offsetY: 0,
                },
              },
            },
          ],
          colors: ["#16C62E", "#AEEA00", "#D7263D"],
          xaxis: {
            categories: [
              "Enero",
              "Febrero",
              "Marzo",
              "Abril",
              "Mayo",
              "Junio",
              "Julio",
              "Agosto",
            ],
          },
          fill: {
            opacity: 1,
          },
          legend: {
            position: "top",
            offsetX: 0,
            offsetY: 0,
          },
        },
        opciones: {
          chartOptions: {
            chart: {
              type: "bar",
              height: 350,
              stacked: true,
              stackType: "100%",
            },
            responsive: [
              {
                breakpoint: 480,
                options: {
                  legend: {
                    position: "bottom",
                    offsetX: -10,
                    offsetY: 0,
                  },
                },
              },
            ],
            xaxis: {
              categories: [
                "2011 Q1",
                "2011 Q2",
                "2011 Q3",
                "2011 Q4",
                "2012 Q1",
                "2012 Q2",
                "2012 Q3",
                "2012 Q4",
              ],
            },
            fill: {
              opacity: 1,
            },
            legend: {
              position: "right",
              offsetX: 0,
              offsetY: 50,
            },
          },
        },
        seriesr: [
          {
            name: "PRODUCT A",
            data: [44, 55, 41, 67, 22, 43, 21, 49],
          },
          {
            name: "PRODUCT B",
            data: [13, 23, 20, 8, 13, 27, 33, 12],
          },
          {
            name: "PRODUCT C",
            data: [11, 17, 15, 15, 21, 14, 15, 13],
          },
        ],
      },
      compositionKPINegocio: {
        series: [
          {
            name: "Promotores",
            data: [44, 55, 41, 67, 22, 43, 21, 49],
          },
          {
            name: "Neutros",
            data: [13, 23, 20, 8, 13, 27, 33, 12],
          },
          {
            name: "Detractores",
            data: [11, 17, 15, 15, 21, 14, 15, 13],
          },
        ],
        options: {
          chart: {
            type: "bar",
            height: 350,
            stacked: true,
          },
          colors: ["#4A148C", "#7319D5", "#D7263D"],
          plotOptions: {
            bar: {
              horizontal: true,
            },
          },
          stroke: {
            width: 1,
            colors: ["#fff"],
          },
          title: {
            text: "",
          },
          xaxis: {
            categories: [
              "Enero",
              "Febrero",
              "Marzo",
              "Abril",
              "Mayo",
              "Junio",
              "Julio",
              "Agosto",
            ],
            labels: {
              formatter: function (val) {
                return val;
              },
            },
          },
          yaxis: {
            title: {
              text: undefined,
            },
          },
          tooltip: {
            y: {
              formatter: function (val) {
                return val;
              },
            },
          },
          fill: {
            opacity: 1,
          },
          legend: {
            position: "top",
            horizontalAlign: "left",
            offsetX: 40,
          },
        },
      },
    };
  },

  methods: {
    async callService() {
      await KpiBusinessService.getSummaryKPINegocio()
        .then((data) => {
          this.summaryKPINegocio = data;
        })
        .catch((err) => console.dir(err));

      await KpiBusinessService.getHistoryKPINegocio()
        .then((data) => {
          this.historyKPINegocio = data;
        })
        .catch((err) => console.dir(err));

      await KpiBusinessService.getRatioHistoryKPINegocio()
        .then((data) => {
          console.log("ratio", data);
          this.ratioHistoryKPINegocio.series = data.series;
        })
        .catch((err) => console.dir(err));

      await KpiBusinessService.getCompositionKPINegocio()
        .then((data) => {
          this.compositionKPINegocio = data;
        })
        .catch((err) => console.dir(err));
    },
  },
  async mounted() {
    this.callService();
  },
};
</script>

<style scoped>
.box-graphics {
  max-width: 1400px;
}
.shrink {
  width: 150px;
}
.bar {
  width: 350px;
}

.resumen {
  display: flex;
  width: 100%;
  height: 250px;
  box-shadow: 0px 3px 1px -2px rgb(0 0 0 / 20%),
    0px 2px 2px 0px rgb(0 0 0 / 14%), 0px 1px 5px 0px rgb(0 0 0 / 12%);
  border-radius: 4px;
  justify-content: center;
  margin: 25px 0px 25px 0px;
}

.resumen > .resumen-detail {
  width: 17%;
  display: flex;
  flex-direction: column;
  margin-top: 50px;
}
.resumen > .resumen-detail > .resumen-detail-item {
  width: 100%;
  display: flex;
  flex-direction: row;
  justify-content: space-between;
}
.resumen > .resumen-detail > .resumen-detail-item > div:first-child {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  width: 55%;
}
.resumen > .resumen-detail > .resumen-detail-item > div {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  width: 15%;
}

.resumen > .resumen-bar {
  display: flex;
  width: 60%;
  height: auto;
}
.resumen-title {
  display: flex;
  flex-direction: row;
  width: 100%;
  border: solid black 1px;
  justify-content: space-between;
}
.resumen-content {
  display: flex;
  flex-direction: row;
  width: 100%;
  border: solid black 1px;
  justify-content: space-between;
  margin-bottom: 15px;
}

.seguimiento {
  width: 100%;
  display: flex;
  box-shadow: 0px 3px 1px -2px rgb(0 0 0 / 20%),
    0px 2px 2px 0px rgb(0 0 0 / 14%), 0px 1px 5px 0px rgb(0 0 0 / 12%);
  border-radius: 4px;
  justify-content: center;
  margin: 25px 0px 25px 0px;
  height: 500px;
}
.seguimiento-costo {
  width: 45%;
  margin: 2px;
}
.seguimiento-periodo {
  width: 45%;
  margin: 2px;
}
.list-top-10 {
  display: flex;
  flex-direction: column;
  width: 100%;
  padding: 50px;
  margin-top: 50px;
  box-shadow: 0px 3px 1px -2px rgb(0 0 0 / 20%),
    0px 2px 2px 0px rgb(0 0 0 / 14%), 0px 1px 5px 0px rgb(0 0 0 / 12%);
  border-radius: 4px;
  margin: 25px 0px 25px 0px;
}

.risk_classification {
  width: 15px;
  height: 15px;
  border-radius: 4px;
  margin: 0px 5px 0px 5px;
}
.risk {
  width: 15%;
  margin: 0px 5px 0px 5px;
}
.concurrence {
  width: 15%;
  margin: 0px 5px 0px 5px;
}
.impact {
  width: 15%;
  margin: 0px 5px 0px 5px;
}
.strategy {
  width: 10%;
  margin: 0px 5px 0px 5px;
}
.contingency {
  width: 20%;
  margin: 0px 5px 0px 5px;
}
.responsible {
  width: 20%;
  margin: 0px 5px 0px 5px;
}
</style>
